Description
Since r36616 modules that have protected methods and are extended on to another class cannot call super. Here is an example:

module A

def inherited klass
super

end

end

module B
protected

def inherited klass
super

end

end

class C
extend B
extend A
end

classZ<C
end

Before r36616 this code would work, but after r36616 this code raises an exception. I've attached a test case.

Associated revisions

Revision ceece4650a1de6189f2705cbf8120f6679a1af8f - 08/20/2012 11:36 AM - nobu (Nobuyoshi Nakada)

vm_insnhelper.c: iclass as klass in cfp

e vm_insnhelper.c (vm_call_method): follow iclasses as klass in cfp
but not included modules. [ruby-core:47241] [Bug #6891]

¢ vm_insnhelper.c (vm_call_bmethod): pass defined_class to follow
proper ancestors. [ruby-core:47241] [Bug #6891]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@36736 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision ceece465 - 08/20/2012 11:36 AM - nobu (Nobuyoshi Nakada)
vm_insnhelper.c: iclass as klass in cfp
e vm_insnhelper.c (vm_call_method): follow iclasses as klass in cfp
but not included modules. [ruby-core:47241] [Bug #6891]
e vm_insnhelper.c (vm_call_bmethod): pass defined_class to follow

proper ancestors. [ruby-core:47241] [Bug #6891]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@36736 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 08/20/2012 08:36 PM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Closed

06/12/2025 12




- % Done changed from 0 to 100

This issue was solved with changeset r36736.
Aaron, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.
May Ruby be with you.
